\chapter{Prior models for discrete latent states}
\label{chap:latent-distributions}
In the previous chapter, we explored latent space models applied to the forecasting of hourly relative humidity records in a building.
We showed that a discrete representation of this data allows for simpler parameter estimation and better interpretability, without degrading the performance of the model, in terms of precision and quality of confidence intervals.
Whereas we limited ourselves to simple Markovian prior models, in this chapter we experiment with recent advances in complex distribution modelling, such as diffusion bridges.

This chapter is organized as follows: in Section~\ref{sec:chap3-introduction}, we introduce the limitation behind using autoregressive priors, as well as the appeal of diffusion probabilistic models, before proposing a new mathematical framework for discrete latent models allowing estimating all parameters jointly.
We review related works in Section~\ref{sec:chap3-related-works}, before presenting our methodology in Section~\ref{sec:chap3-approach}.
In Section~\ref{sec:chap3-experiments}, we present a set of experiments conducted on a toy problem, two image datasets and the relative humidity forecasting task.
Due to limitations arising during the training phase, we propose an extension of diffusion applied to discrete data in Section~\ref{sec:chap3-extension-dicrete-data}, and discuss the overhaul results of this new approach in Section~\ref{chap3-conclusion}.

The results presented in this chapter are adapted from the following contribution: {\em Diffusion Bridges Vector Quantized Variational Autoencoders}, Cohen, M., Quispe, Q., Le Corff, S., Ollion, C., Moulines, E., Proceedings of the 39th International Conference on Machine Learning, Volume 162.

\section{Introduction}
\label{sec:chap3-introduction}
Vector Quantized-Variational AutoEncoders (VQ-VAE) are generative models based on discrete latent representations of the data, where inputs are mapped to a finite set of learned embeddings.
To generate new samples, an autoregressive prior distribution over the discrete states must be trained separately.
This prior is generally very complex and leads to slow generation.
Additionally, the implementation of VQ-VAE relies on many practical tricks, already highlighted in the previous chapter, see Section~\ref{sec:chap2-discrete-latent-models}.
Despite these limitations, the VQ-VAE and its derived models have been successfully applied in image and speech generation \cite{oord2017neural, esser2021taming, ramesh2021zero}.
One particular limitation we now address revolves around the prior model.

Firstly, when training the VQ-VAE, the prior distribution of the discrete variables is initially assumed to be uninformative, in practice uniform.
Only in a subsequent training step, high-dimensional autoregressive models such as the PixelCNN \cite{oord2016conditional, salimans2017pixelcnn, chen2018pixelsnail} or WaveNet \cite{oord2016wavenet} are estimated to obtain a complex prior distribution.
Joint training of the prior and the Auto-Encoder is a challenging task for which no satisfactory solution exists yet.

Secondly, the autoregressive nature of the proposed prior models (PixelCNN and WaveNet) has several drawbacks in the general case, which are the same in the observation and latent space.
The data is assumed to have a fixed sequential order, which forces the generation to start at a certain point.
For instance, when modelling an image, such a prior would typically start modelling the upper left corner, then span the image in an arbitrary way.
At each step, a new latent variable is sampled using the previously sampled pixels.
This is also the case when modelling a complex, high dimensional lattice of latent vectors.
During inference, the model may then accumulate prediction errors.
Additionally, the runtime process, which depends mainly on the number of network evaluations, is sequential and depends on the size of the image or the multi-dimensional lattice.
The influence of the prior is further explored in \cite{razavi2019generating}, where VQ-VAE is used to sample images on a larger scale, using two layers of discrete latent variables, and \cite{willetts:2021} use hierarchical discrete VAEs with numerous layers of latent variables.
Other works such as \cite{esser2021taming, ramesh2021zero} have used Transformers to autoregressively model a sequence of latent variables: while these works benefit from the recent advances of Transformers for large language models, their autoregressive process still suffers from the same drawbacks as PixelCNN-like priors.

A promising class of models that depart from autoregressive models are Diffusion Probabilistic Models \cite{sohldickstein2015deep, ho2020denoising} and closely related Score-Matching Generative Models \cite{song2019generative, de2021simulating}.
The general idea is to apply a corrupting Markovian process on the data through $T$ corrupting steps and learn a neural network that gradually \textit{denoises} or reconstructs the original samples from the noisy data.
For example, when sampling images, an initial sample is drawn from an uninformative distribution and reconstructed iteratively using the trained Markov kernel.
This process is applied to all pixels simultaneously, so no fixed order is required and the sampling time does not depend on sequential predictions that depend on the number of pixels, but on the number of steps $T$.
While this number of steps can be large ($T=1000$ is typical), simple improvements enable to reduce it dramatically and obtain $\times 50$ speedups \cite{song2021denoising}.
These properties have led diffusion probability models to receive much attention in the context of continuous input modelling.

Our work addresses both limitations by introducing a new mathematical framework that extends the VQ-VAE to non autoregressive priors.
The main claim of our proposed approach is that using diffusion bridges in a continuous space is a very efficient way to learn complex discrete distributions, with support on a large space.
We propose the following contributions:
\begin{itemize}
	\item We develop a new mathematical framework for quantized latent models, that extends and generalizes the standard VQ-VAE.
	      Our method enables end-to-end training and, in particular, bypasses the separate training of an autoregressive prior.
	\item To this end, we build a diffusion bridge between a continuous coded vector and a non-informative prior distribution.
	      The latent discrete states are then given as random functions of these continuous vectors.
	\item We show that our model is competitive with the autoregressive prior on the mini-Imagenet and CIFAR dataset and is efficient in both optimization and sampling.
	      We also demonstrate an application for time series, by improving on the variational model presented previously, see Section~\ref{sec:chap2-vadiltis-model}.
\end{itemize}
Figure~\ref{fig:archi} describes the complete architecture of our model.

\begin{figure}[h]
	\centering
	\includegraphics[width=\linewidth]{images/diffusion-bridges/archi.png}
	\caption{Our proposed architecture, for a prior based on a Ornstein-Uhlenbeck bridge. The top pathway from \textit{input image} to $\latentcont^0$, to $\quantized^0$, to \textit{reconstructed image} resembles the original VQ-VAE model. The vertical pathway from $(\latentcont^0, \quantized^0)$ to $(\latentcont^T, \quantized^T)$ and backwards is based on a denoising diffusion process. See Section~\ref{sec:chap3-ou-process} and Algorithm~\ref{alg:sample} for the corresponding sampling procedure.}
	\label{fig:archi}
\end{figure}

% We only require an embedded space, an uninformative target distribution (here a Gaussian law), and use a continuous bridge process to learn the discrete target distribution.
% In that direction, our contribution is inspired by the literature but also significantly different.
% Our procedure departs from the diffusion probabilistic model approach of \cite{ho2020denoising}, which highlights the role of bridge processes in denoising continuous target laws, and from \cite{hoogeboom2021argmax}, where multinomial diffusions are used to noise and denoise but prevent the use of the expressiveness of continuous bridges, and also do not scale well with $K$ as remarked by its authors.
% Although we target a discrete distribution, our approach does not suffer from this limitation.

\section{Related Works}
\label{sec:chap3-related-works}
\paragraph{Discrete Generative denoising.}
There exists approaches to diffusion probabilistic models, such as presented for the diffusion bridges, in the context of discrete data.
In \cite{hoogeboom2021argmax}, the authors propose multinomial diffusion to gradually add categorical noise to discrete samples for which the generative denoising process is learned.
Unlike alternatives such as normalizing flows (see \cite{kobyzev2021NF} for a review), the diffusion proposed by the authors for discrete variables does not require gradient approximations because the parameter of the diffusion is fixed.

Such diffusion models are optimized using variational inference to learn the denoising process, i.e., the bridge that aims at inverting the multinomial diffusion.
In \cite{hoogeboom2021argmax}, the authors propose a variational distribution based on bridge sampling.
In \cite{austin2021structured}, the authors improve the idea by modifying the transition matrices of the corruption scheme with several tricks.
The main one is the addition of absorbing states in the corruption scheme by replacing a discrete value with a MASK class, inspired by recent Masked Language Models like BERT.
In this way, the corrupted dimensions can be distinguished from the original ones instead of being uniformly sampled.
% ii) Use of transition matrices that mimic Gaussian kernels in continuous space by imitating a diffusion model in continuous space through the use of a discretised truncated Gaussian distribution. However, this assumes a natural ordering of the dimensions, which is not the case in our latent space. iii)  A corruption based on nearest neighbors in the embedding space using previously trained embeddings of discrete categories. This scheme was developed for token embeddings such as pre-trained word embeddings and is not applicable in our case.
One drawback of their approach, mentioned by the authors, is that the transition matrix does not scale well for a large number of embedding vectors, which is typically the case in VQ-VAE.

Compared to discrete generative denoising, our approach takes advantage of the fact that the discrete latent distribution depends solely on an auxiliary continuous distribution.
We derive a novel model based on continuous-discrete diffusion that we believe is simpler and more scalable than the models mentioned in this section.

\paragraph{Generative denoising applied to a latent space.}
Instead of modelling the data directly, \cite{vahdat2021score} propose to perform score matching in a latent space.
The authors propose a complete generative model and are able to train the encoder/decoder and score matching end-to-end.
Their method also achieve excellent visual patterns and results but relies on a number of optimization heuristics necessary for stable training.
In \cite{mittal2021symbolic}, the authors have also applied such an idea in a generative music model.
Instead of working in a continuous latent space, our method is specifically designed for a discrete latent space as in VQ-VAEs.

In the model proposed by \cite{gu2021vector}, the autoregressive prior is replaced by a discrete generative denoising process, which is perhaps closer to our idea.
However, the authors focus more on a text-image synthesis task where the generative denoising model is traine based on an input text: it generates a set of discrete visual tokens given a sequence of text tokens.
They also consider the VQ-VAE as a trained model and focus only on the generation of latent variables.
This work focuses instead on deriving a full generative model with a sound probabilistic interpretation that allows it to be trained end-to-end.

\section{Diffusion bridges VQ-VAE}
\label{sec:chap3-approach}
\subsection{Model and loss function}
Assume that the distribution of the input $y\in\rset^m$ depends on a hidden discrete state $\quantized \in \embedspace = \{\codebook_1,\ldots,\codebook_K\}$ with $\codebook_k\in\rset^d$ for all $1\leqslant k \leqslant K$.
Let $p_\theta$ be the joint probability density of $(\quantized,y)$%: for all $(\quantized,y)\in\embedspace\times\rset^m$,
$$
	(\quantized,y)\mapsto p_\theta(\quantized,y) = p_\theta(\quantized) p_\theta(y|\quantized)\,,
$$
where $\theta \in \rset^p$ are unknown parameters.
Consider first an encoding function $f_\phi$ and write $\latentcont(y)= f_\phi(y)$ the encoded data.
In the original VQ-VAE, the authors proposed $q_\phi(\quantized|y) = \delta_{\codebook_{k^*_y}}(\quantized)\,,$ as the variational distribution to approximate $p_\theta(\quantized|y)$, where $\delta$ is the Dirac mass and $k^*_y = \mathrm{argmin}_{1\leqslant k \leqslant K}\left\{\|\latentcont(y)-\codebook_k\|_2\right\}$, where $\phi\in\rset^r$ are all the variational parameters.
%  This approach  does not suffer from usual posterior collapse in VAE setting but involves many practical tricks and still suffer from serious limitations, see \cite{}. First, the authors proposed a rough approximation of the gradient of the loss function by copying gradients from the decoder input  to the
% encoder output. Second, the prior distribution $p_\theta(\quantized)$ is first assumed to be uniform during training of the VQ-VAE. However,  very high dimensional autoregressive models such as PixelCNN \cite{} or WaveNet \cite{} are then trained to obtain a complex prior distribution during a second phase of training. Training the prior and the VQ-VAE jointly is a challenging task that has not yet received satisfactory solutions.

In this paper, we introduce a diffusion-based generative VQ-VAE. This model allows to propose a VAE approach with an efficient joint training of the prior and the variational approximation. %Diffusion-based generative models have recently shown striking results in image generation and can be used in our setting to define noising and denoising processes in a continuous state space to sample sequences of discrete representations.
Assume that $\quantized$ is a sequence, i.e. $\quantized= \quantized^{0:T}$, where the superscript refers to the time in the diffusion process.
Consider the following joint probability distribution
$$
	p_{\theta}(\quantized^{0:T},y) = p^{\quantized}_{\theta}(\quantized^{0:T})p^y_{\theta}(y|\quantized^{0})\,.
$$
The latent discrete state $\quantized^0$ used as input in the decoder is the final state of the chain $(\quantized^T,\ldots,\quantized^0)$. We further assume that $p_{\theta}^{\quantized}(\quantized^{0:T})$ is the marginal distribution of
$$
	p_{\theta}(\quantized^{0:T},\latentcont^{0:T}) = p^{\latentcont}_{\theta,T}(\latentcont^T) p^{\quantized}_{\theta,T}(\quantized^T|\latentcont^T)
	\prod_{t=0}^{T-1}p^{\latentcont}_{\theta,t|t+1}(\latentcont^t|\latentcont^{t+1})p^{\quantized}_{\theta,t}(\quantized^t|\latentcont^t)\,.
$$
In this setting, $\{\latentcont^t\}_{0\leqslant t\leqslant T}$ are continuous latent states in $\mathbb{R}^{d\times N}$ and conditionally on $\{\latentcont^t\}_{0\leqslant t\leqslant T}$ the $\{\quantized^t\}_{0\leqslant t\leqslant T}$ are independent with discrete distribution with support $\embedspace^N$.
This means that we model jointly $N$ latent states as this is useful for many applications such as image generation or time series forecasting.
The continuous latent state is assumed to be a Markov chain and at each time step $t$ the discrete variable $\quantized^t$ is a random function of the corresponding $\latentcont^t$.  Although the continuous states are modeled as a Markov chain, the discrete variables arising therefrom have a more complex statistical structure (and in particular are not Markovian).

The prior distribution of $\latentcont^T$ is assumed to be uninformative ; the density of the final latent state $\latentcont^0$ can be factorized as a sequence of denoising transition densities $\{p^{\latentcont}_{\theta,t|t+1}\}_{0\leqslant t\leqslant T-1}$.
Only this last state is mapped to the embedding space and decoded to compute the conditional law of the data given the latent states.

%Most approaches \cite{} using diffusion probabilistic models for $\{\quantized^t\}_{T\leqslant t\leqslant 0}$ are based on a fixed diffusion process. A notable exception is \cite{} where the authors learned a Gaussian diffusion process. This specific choice was motivated by the design of the generative model which required to "invert" the diffusion process, i.e. to sample from a bridge process associated with Stochastic Differential Equation (SDE), which is explicit only for very few classes of diffusions.

Since the conditional law $p_{\theta}(\quantized^{0:T},\latentcont^{0:T}| y)$ is not available explicitly, this work focuses on variational approaches to provide an approximation. Then, consider the following variational family:
$$
	q_{\phi}(\quantized^{0:T},\latentcont^{0:T}| y) = \delta_{\latentcont(y)}(\latentcont^0)q_{\phi,0}^{\quantized}(\quantized^0|\latentcont^0)
	\prod_{t=1}^T\left\{ q^{\latentcont}_{\phi,t|t-1}(\latentcont^t|\latentcont^{t-1})q^{\quantized}_{\phi,t}(\quantized^t|\latentcont^t)\right\}\,.
$$
The family $\{q^{\latentcont}_{\phi,t|t-1}\}_{1\leqslant t \leqslant T}$ of forward "noising" transition densities are chosen to be the transition densities of a continuous-time process $(Z_t)_{t\geqslant 0}$ with $Z_0 = \latentcont(y)$. Sampling the diffusion bridge $(\tilde Z_t)_{t\geqslant 0}$, i.e. the law of the process $(Z_t)_{t\geqslant 0}$ conditioned on $Z_0 = \latentcont(y)$ and $Z_T = \latentcont^T$ is a challenging problem for general diffusions, see for instance \cite{beskos2008mcmc,lin2010generating,bladt2016simulation}. By the Markov property, the marginal density at time $t$ of this conditioned process is given by:
\begin{equation}
	\label{eq:markov:bridge}
	\bckw^{\latentcont}_{\phi,t|0,T}(\latentcont^t|\latentcont^0,\latentcont^T) = \frac{q^{\latentcont}_{\phi,t|0}(\latentcont^t|\latentcont^{0})q^{\latentcont}_{\phi,T|t}(\latentcont^T|\latentcont^{t})}{q^{\latentcont}_{\phi,T|0}(\latentcont^T|\latentcont^{0})}\,.
\end{equation}
The Evidence Lower BOund (ELBO) is then defined, for all $(\theta,\phi)$, as
\begin{equation}
	\mathcal{L}(\theta,\phi) = \mathbb{E}_{q_{\phi}}\left[\log \frac{p_{\theta}(\quantized^{0:T},\latentcont^{0:T},y)}{q_{\phi}(\quantized^{0:T},\latentcont^{0:T}| y)}\right]\,,
	\label{eq:chap3-elbo}
\end{equation}
where $\mathbb{E}_{q_{\phi}}$ is the expectation under $q_{\phi}(\quantized^{0:T},\latentcont^{0:T}| y)$.
\begin{lemma}
	\label{lem:loss}
	For all $(\theta,\phi)$, the ELBO $\mathcal{L}(\theta,\phi)$ is:
	$$
		\mathcal{L}(\theta,\phi) = \mathbb{E}_{q_{\phi}}\left[\log p^y_{\theta}(y|\quantized^{0})\right] + \sum_{t=0}^T \mathcal{L}_t(\theta,\phi)
		+ \sum_{t=0}^T\mathbb{E}_{q_{\phi}}\left[\log \frac{p_{\theta,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}{q_{\phi,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}\right]\,,
	$$
	where, for $1\leqslant t \leqslant T-1$,
	\begin{align*}
		\mathcal{L}_0(\theta,\phi) & = \mathbb{E}_{q_\phi}\left[\log p^{\latentcont}_{\theta, 0|1}(\latentcont^0|\latentcont^{1})\right]\,,                                                                                                  \\
		\mathcal{L}_t(\theta,\phi) & = \mathbb{E}_{q_{\phi}}\left[\log \frac{p_{\theta,t-1|t}^{\latentcont}(\latentcont^{t-1}|\latentcont^{t})}{q^{\latentcont}_{\phi,t-1|0,t}(\latentcont^{t-1}|\latentcont^{0},\latentcont^{t})}\right]\,, \\
		\mathcal{L}_T(\theta,\phi) & = \mathbb{E}_{q_{\phi}}\left[\log \frac{p^{\latentcont}_{\theta,T}(\latentcont^{T})}{q_{\phi,T|0}^{\latentcont}(\latentcont^{T}|\latentcont^{0})}\right]\,.
	\end{align*}
\end{lemma}
\begin{proof}
	The proof is standard and postponed to Appendix~\ref{ap:loss}.
\end{proof}
The three terms of the objective function can be interpreted as follows:
$$
	\mathcal{L}(\theta,\phi) = \mathcal{L}^{rec}(\theta,\phi) + \sum_{t=0}^T \mathcal{L}_t(\theta,\phi) + \sum_{t=0}^T \mathcal{L}^{reg}_t(\theta,\phi)
$$
with $\mathcal{L}^{rec} = \mathbb{E}_{q_{\phi}}[\log p^y_{\theta}(y|\quantized^{0})]$ a reconstruction term, $\mathcal{L}_t$ the diffusion term, and an extra term \begin{equation}
	\mathcal{L}^{reg}_t = \mathbb{E}_{q_{\phi}}\left[\log \frac{p_{\theta,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}{q_{\varphi,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}\right]\,,
\end{equation}
which may be seen as a regularization term as discussed in next sections.
% Noising and denoising over the random variables $\{\latentcont^t\}_{0\leqslant t\leqslant T}$ is sensitive to the initial scaling of the distance between embedded data and embeddings in $\embedspace$. An appealing solution to avoid this problem is to normalize all the distances and use for instance spherical projection.
\subsection{Application to Ornstein-Uhlenbeck processes}
\label{sec:chap3-ou-process}
%\paragraph{Application to Ornstein-Uhlenbeck processes.}
Consider for instance the following Stochastic Differential Equation (SDE) to add noise to the normalized inputs:
\begin{equation}
	\label{eq:ou}
	\mathrm{d}Z_t = -\vartheta (Z_t - z_*)\mathrm{d}t + \eta\mathrm{d}W_t\,,
\end{equation}
where $\vartheta, \eta>0$, $z_*\in\mathbb{R}^{d\times N}$ is the target state at the end of the noising process and $\{W_t\}_{0\leqslant t\leqslant T}$ is a standard Brownian motion in $\mathbb{R}^{d\times N}$. We can define the variational density by integrating this SDE along small step-sizes. Let $\delta_t$ be the time step between the two consecutive latent variables $\latentcont^{t-1}$ and $\latentcont^{t}$. In this setting, $q^{\latentcont}_{\phi,t|t-1}(\latentcont^t|\latentcont^{t-1})$ is a Gaussian probability density function with mean $z_* + (\latentcont^{t-1}-z_*)\mathrm{e}^{-\vartheta \delta_t}$ in $\mathbb{R}^{d\times N}$ and covariance matrix $(2\vartheta)^{-1}\eta^2(1-\mathrm{e}^{-2\vartheta\delta_t})\mathbf{I}_{dN}$, where for all $n\geqslant 1$, $\mathbf{I}_{n}$ is the identity matrix with size $n\times n$. Asymptotically the process is a Gaussian with mean $z_*$ and variance $\eta^2(2\vartheta)^{-1} \mathbf{I}_{dN}$.

The denoising process amounts then to sampling from the bridge associated with the SDE, i.e. sampling $\latentcont^{t-1}$ given $\latentcont^0$ and $\latentcont^t$. The law of this bridge is explicit for the Ornstein-Uhlenbeck diffusion \eqref{eq:ou}.
Using \eqref{eq:markov:bridge},
$$
	\bckw^{\latentcont}_{\phi,s|0,t}(\latentcont^{s}|\latentcont^{t},\latentcont^{0}) \propto q^{\latentcont}_{\varphi,s|0}(\latentcont^{t-1}|\latentcont^{0}) q^{\latentcont}_{\varphi,t|s}(\latentcont^{t}|\latentcont^{s})\,,
$$
where $0\leqslant s\leqslant t$, so that $\bckw^{\latentcont}_{\phi,t-1|0,t}(\latentcont^{t-1}|\latentcont^{t},\latentcont^{0})$ is a Gaussian probability density function with mean
$$
	\tilde \mu_{\phi,t-1|0,t}(\latentcont^0,\latentcont^t) = \frac{\beta_t}{1-\bar{\alpha}_t}\left(z_* + \sqrt{\bar{\alpha}_{t-1}}(\latentcont^0-z_*)\right)
	+ \frac{1-\bar{\alpha}_{t-1}}{1-\bar{\alpha}_t}\sqrt{\alpha}_t\left(\latentcont^t - (1 - \sqrt{\alpha_t} )z_*\right)
$$
and covariance matrix
$$
	\tilde \sigma^2_{\phi,t-1|0,t} = \frac{\eta^2}{2\vartheta}\frac{1- \bar \alpha_{t-1}}{1- \bar \alpha_{t}}\beta_t\, \mathbf{I}_{dN}\,,
$$
where $\beta_t = 1 - \mathrm{exp}(-2\vartheta \delta_t)$, $\alpha_t = 1-\beta_t$ and $\bar{\alpha}_t = \prod_{s=1}^{t}\alpha_s$.
Note that the bridge sampler proposed in \cite{ho2020denoising} is a specific case of this setting with $\eta = \sqrt{2}$, $z_*=0$ and $\vartheta = 1$.
% Let $\pi$ be a probability distribution function with respect to the Lebesgue measure such that $\pi \propto \mathrm{exp}(-G)$ where $G$ is continuously differentiable.
% We consider a sampling method based on the Euler discretization of the overdamped Langevin
% stochastic differential equation (SDE):
% $$
% \mathrm{d}U_t = -\nabla G(U_t)\mathrm{d}t + \sqrt{2}\mathrm{d}W_t\,.
% $$
% Under standard assumptions, see \cite{}, the convergence to $\pi$ holds at geometric rate. In this case, $\pi$ is the equilibrium distribution, and our model will target this distribution as initial law of $Z_e^T$

\paragraph{Choice of denoising model $p_\theta$.}
Following \cite{ho2020denoising}, we propose a Gaussian distribution for $p_{\theta,t-1|t}^{\latentcont}(\latentcont^{t-1}|\latentcont^{t})$ with mean $\mu_{\theta,t-1|t}(\latentcont^{t},t)$ and variance $\sigma_{\theta,t-1|t}^2\,\mathbf{I}_{dN}$. In the following, we choose $$
	\sigma_{\theta,t-1|t}^2 = \frac{\eta^2}{2\vartheta}\frac{1- \bar \alpha_{t-1}}{1- \bar \alpha_{t}}\beta_t\,
$$
so that the term $\mathcal{L}_t$ of Lemma~\ref{lem:loss} writes
$$
	2\sigma_{\theta,t-1|t}^2\mathcal{L}_t(\theta,\phi)
	= -\mathbb{E}_{q_\phi}\left[\left\|\mu_{\theta,t-1|t}(\latentcont^{t},t) - \tilde \mu_{\varphi,t-1|0,t}(\latentcont^0,\latentcont^t)\right\|_2^2\right]\,.
$$
In addition, under $q_\phi$, $\latentcont^t$ has the same distribution as
$$
	\latentcontpred^t(\latentcont^{0},\varepsilon_t) = z_* + \sqrt{\bar \alpha_t}(\latentcont^{0}-z_*) + \sqrt{\frac{\eta^2}{2\vartheta}(1-\bar\alpha_t)}\varepsilon_t\,,
$$
where $\varepsilon_t \sim \mathcal{N}(0,\mathbf{I}_{dN})$.
% we can reparametrise the model to predict the noise, given that $Z_e^{t}=Z_e^{0}\mathrm{e}^{-\theta\delta t} + \sigma_{t} \varepsilon$ . (adapt with $z*$)
% \begin{equation}
%     Z_e^{0}=(Z_e^{t} - \sigma_{t}\varepsilon) \mathrm{e}^{\theta\delta t}
% \end{equation}
% \begin{align*}
% q^u_{\phi,t}(Z_e^{t-1}|Z_e^{t},Z_e^{0})=\mathcal{N}(\tilde \mu_{t|t-1,0} (Z_e^{t},Z_e^{0}),\,\sigma^{2})\\
% p^u_{\theta,t}(Z_e^{t-1}|Z_e^t)=\mathcal{N}( \mu_{\theta,t|t-1,0} (Z_e^{t},t),\,\sigma^{2})
% \end{align*}
Then, for instance in the case $z_*=0$, $\tilde \mu_{\phi,t-1|0,t}$ can be reparameterised as follows:
$$
	\tilde \mu_{\phi,t-1|0,t}(\latentcont^0,\latentcont^t) =
	\frac{1}{\sqrt{\alpha_t}}\left(\latentcontpred^t(\latentcont^0,\varepsilon_t) - \sqrt{\frac{\eta^2}{2\vartheta (1-\bar{\alpha}_t)}}\beta_t\varepsilon_t\right)\,.
$$
We therefore propose to use
$$
	\mu_{\theta,t-1|t}(\latentcont^{t},t) =
	\frac{1}{\sqrt{\alpha_t}}\left(\latentcont^t - \sqrt{\frac{\eta^2}{2\vartheta (1-\bar{\alpha}_t)}}\beta_t\varepsilon_\theta(\latentcont^{t},t)\right)\,,
$$
which yields
\begin{equation}
	\label{eq:hoparam}
	\mathcal{L}_t(\theta,\phi) \\
	= \frac{-\beta_t}{2\alpha_t(1-\bar\alpha_{t-1})}\mathbb{E}\left[\left\|\varepsilon_t - \varepsilon_\theta(\latentcontpred^t(\latentcont^{0},\varepsilon_t) ,t) \right\|_2^2\right]\,.
\end{equation}

Several choices can be proposed to model the function $\varepsilon_\theta$. The deep learning architectures considered in the numerical experiments are discussed in Appendix~\ref{ap:networks} and ~\ref{ap:additionaltoy}. Similarly to \cite{ho2020denoising}, we use a stochastic version of our loss function: sample $t$ uniformly in $\{0, \ldots, T\}$, and consider $\mathcal{L}_t(\theta,\phi)$ instead of the full sum over all $t$. The final training algorithm is described in Algorithm~\ref{alg:train} and the sampling procedure in Algorithm~\ref{alg:sample}.

% The mean is parameterized as follows.
% \begin{equation}
%     \mu_\theta(\latentcont^{t},t)=\tilde \mu_{t}((\latentcont^{t} - \sigma_{t}\boldsymbol{\varepsilon_{\theta}(\latentcont^{t})}) \mathrm{e}^{\theta\delta t},\latentcont^{t})
% \end{equation}

% To sample from $p^u_{\theta,t}(Z_e^{t-1}|Z_e^t)$, we predict the noise $\boldsymbol{\varepsilon_{\theta}}$ first.


%\paragraph{Extension to more complex bridge processes.}

%\paragraph{Discussion about score-based generative modeling.}

% \medskip

% Insert a graphical explanation of the full model, with encoding, decoding, and diffusion process \todo{anyone}

\paragraph{Connections with the VQ-VAE loss function. } In the special case where $T=0$, our loss function can be reduced to a standard VQ-VAE loss function. In that case, write $\quantized = \quantized^0$ and $\latentcont = \latentcont^0$, the ELBO then becomes:
$$
	\mathcal{L}(\theta,\phi) = \mathbb{E}_{q_{\varphi}}\left[\log p^y_{\theta}(y|\quantized)\right]
	+ \mathbb{E}_{q_{\phi}}\left[\log \frac{p_{\theta}^{\quantized}(\quantized|\latentcont)}{q_{\varphi}^{\quantized}(\quantized|\latentcont)}\right]\,,
$$
Then, if we assume that $p_{\theta}^{\quantized}(\quantized|\latentcont) = \mathrm{Softmax}\{-\|\latentcont - \codebook_k\|^2_2\}_{1\leq k \leq K}$ and that  $q_{\phi}^{\quantized}(\quantized|\latentcont)$ is as in \cite{oord2017neural}, i.e. a Dirac mass at $\widehat{\quantized} = \mathrm{argmin}_{1\leq k \leq K}\|\latentcont - \codebook_k\|^2_2$, up to an additive constant, this yields the following random estimation of $\mathbb{E}_{q_{\varphi}}[\log p_{\theta}^{\quantized}(\quantized|\latentcont)/q_{\varphi}^{\quantized}(\quantized|\latentcont)]$,
% \begin{equation}
% \label{eq:lossvqvae}
% \mathbb{E}_{q_{\phi}}\left[\log \frac{p_{\theta}^{\quantized}(\quantized|\latentcont)}{q_{\varphi}^{\quantized}(\quantized|\latentcont)}\right] = -\mathbb{E}_{q_{\varphi}}\left[\log q_{\varphi}^{\quantized}(\quantized|\latentcont)\right]\,.
% \end{equation}
% Choosing $q_{\phi}^{\quantized}(\quantized|\latentcont) = \mathrm{Softmax}\{-\|\latentcont - \codebook_k\|_2\}_{1\leq k \leq K}$ and sampling $\quantized \sim q_{\varphi}^{\quantized}(\quantized|\latentcont)$ yields the following random estimation of \eqref{eq:lossvqvae},
$$
	\widehat{\mathcal{L}}^{reg}_{\quantized}(\theta,\phi) = \|\latentcont - \widehat{\quantized}\|_2
	+ \log \left(\sum_{k=1}^{K}\exp\left\{-\|\latentcont-\codebook_k\|_2\right\}\right)\,.
$$
The first term of this loss is the loss proposed in \cite{oord2017neural} which is then split into two parts using the stop gradient operator.
The last term is simply the additional normalizing term of $p_{\theta}^{\quantized}(\quantized|\latentcont)$.
% which is not considered in \cite{oord2017neural}. % and is useless if no optimization on the embeddings is performed.
%Therefore, our setting encompasses the standard VQ-VAE setting.% without assuming during training that $p_{\theta}^{\quantized}(\quantized|\latentcont)$ is uniform.

\paragraph{Connecting diffusion and discretisation. } Similar to the VQ-VAE case above, it is possible to consider only the term $\mathcal{L}^{reg}_0(\theta,\phi)$ in the case $T > 0$. However, our framework allows for much flexible parameterisation of $p_{\theta,t}^{\quantized}(\quantized^t|\latentcont^t)$ and $q_{\varphi,t}^{\quantized}(\quantized^t|\latentcont^t)$. For instance, the Gumbel-Softmax trick provides an efficient and differentiable parameterisation. A sample $\quantized^t\sim p_{\theta,t}^{\quantized}(\quantized^t|\latentcont^t)$ (resp. $\quantized^t\sim q_{\varphi,t}^{\quantized}(\quantized^t|\latentcont^t)$) can be obtained by sampling with probabilities proportional to $\{\exp\{(-\|\latentcont - \codebook_k\|^2_2 + G_k )/\tau_t\}\}_{1\leq k \leq K}$ (resp. $\{\exp\{(-\|\latentcont - \codebook_k\|^2_2 + \tilde G_k )/\tau\}\}_{1\leq k \leq K}$), where $\{(G_k,\tilde G_k)\}_{1\leq k \leq K}$ are i.i.d. with distribution $\mathrm{Gumbel}(0,1)$, $\tau>0$, and $\{\tau_t\}_{0\leq t \leq T}$ are positive time-dependent scaling parameters. In practice, the third part of the objective function can be computed efficiently, by using a stochastic version of the ELBO, computing a single $\mathcal{L}^{reg}_t(\theta,\varphi)$ instead of the sum (we use the same $t$ for both parts of the ELBO). The term reduces to:
% (see Appendix~\ref{ap:reg} for details):
% \begin{equation}
% \label{eq:reg}
% \mathcal{L}^{reg}_t(\theta,\phi) = \mathbb{E}_{q_{\varphi}}\left[\log \frac{p_{\theta,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}{q_{\varphi,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}\right]
% \approx \gamma_t \mathbb{E}_{q_{\phi}}\left[\left\|\latentcont^{t} - \quantized^t \right\|_2^2\right]\
% \end{equation}

\begin{equation}
	\mathcal{L}^{reg}_t(\theta,\phi) = -\mathrm{KL}(q_\varphi(\quantized^{t}|\latentcont^{t})\|p_\theta(\quantized^{t}|\latentcont^{t}))\,.
\end{equation}
% Where $\gamma_t$ is a weight term which depends on the temperatures chosen in the Gumbel-Softmax.
This terms connects the diffusion and quantization parts as it creates a gradient pathway through a step $t$ of the diffusion process, acting as a regularisation on the codebooks and $\latentcont^t$. Intuitively, maximizing $\mathcal{L}^{reg}_t(\theta,\phi)$ accounts for pushing codebooks and $\latentcont^t$ together or apart depending on the choice of $\tau, \tau_t$. The final end-to-end training algorithm is described in Algorithm~\ref{alg:train}, and further considerations are provided in Appendix~\ref{ap:reg}.

% \paragraph{Connections with discrete diffusion.} Our model also generalizes a discrete diffusion, if we consider a special case with no encoder / decoder. The discrete data $X \in  \{1,\ldots,K\}^N$ is first mapped into (random) projection through the codebooks $\mathcal{E} = \{\rme_1,\ldots,\rme_K\}$, $K\geq 1$. The loss then becomes:
% $$
% \mathcal{L}(\theta,\phi) = \sum_{t=1}^T \mathcal{L}_t(\theta,\varphi)
% + \sum_{t=0}^T\mathbb{E}_{q_{\phi}}\left[\log \frac{p_{\theta,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}{q_{\varphi,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}\right]\,,
% $$

% The first term here corresponds to a continuous diffusion process of the embedded vectors through the codebooks, and the second term can be seen as a regularization term which enables to learn the optimal codebooks alongside the diffusion process. Intuitively, we project the discrete variables in a continuous space in order to build a diffusion process which captures more efficiently the dependencies of the data.

\begin{algorithm}[tb]
	\caption{Training procedure}
	\label{alg:train}
	\begin{algorithmic}
		\REPEAT
		%\STATE \COMMENT{\textit{Compute reconstruction loss}}


		\STATE Compute $\latentcont^0= f_\phi(y)$
		\STATE Sample $\hat{\quantized}^0 \sim q_\phi(\quantized^0|\latentcont^0)$
		\STATE Compute $\textcolor{teal}{\hat{\mathcal{L}}^{rec}(\theta,\phi)} = \log p^y_{\theta}(y|\hat{\quantized}^0)$
		%\STATE \COMMENT{\textit{Compute denoising loss}}

		\STATE Sample $t \sim Uniform(\{0,\ldots, T\})$
		\STATE Sample $\varepsilon_t \sim \mathcal{N}(0,\mathbf{I}_{dN})$
		\STATE Sample $\latentcont^{t} \sim q_\phi(\latentcont^t|\latentcont^0)$ (using $\varepsilon_t$)
		\STATE Compute $\textcolor{olive}{\hat{\mathcal{L}}_t(\theta,\phi)}$ from $\varepsilon_\theta(\latentcont^{t},t)$ and $\varepsilon_t$ using \eqref{eq:hoparam}
		\STATE Compute $\textcolor{violet}{\hat{\mathcal{L}}^{reg}_t(\theta,\phi)}$ from $\latentcont^{t}$ \textit{(see text)}

		%\STATE $\epsilon \sim \mathcal{N}(0,\,\mathbf{I})$
		\STATE $\hat{\mathcal{L}}(\theta,\phi) = \textcolor{teal}{\hat{\mathcal{L}}^{rec}(\theta,\varphi)} + \textcolor{olive}{\hat{\mathcal{L}}_t(\theta,\varphi)} + \textcolor{violet}{\hat{\mathcal{L}}^{reg}_t(\theta,\varphi)}$
		\STATE Perform SGD step on $-\hat{\mathcal{L}}(\theta,\phi)$
		\UNTIL{convergence}
	\end{algorithmic}
\end{algorithm}

\begin{algorithm}[tb]
	\caption{Sampling procedure (for $z_* = 0$)}
	\label{alg:sample}
	\begin{algorithmic}

		\STATE Sample $\latentcont^T \sim \mathcal{N}(0, (2\vartheta)^{-1}\eta^2 \mathbf{I}_{dN})$
		\FOR{$t=T$ {\bfseries to} $1$}
		\STATE Set $\latentcont^{t-1} = \alpha_t^{-1/2}\left(\latentcont^t - \sqrt{\frac{\eta^2}{2\vartheta (1-\bar{\alpha}_t)}}\beta_t\varepsilon_\theta(\latentcont^{t},t)\right)$
		\ENDFOR
		\STATE Sample $\quantized^0 \sim p^{\quantized}_{\theta,0}(\quantized^0|\latentcont^0)$ \COMMENT{\textit{quantization}}
		\STATE Sample $y \sim p^y_{\theta}(y|\quantized^0)$ \COMMENT{\textit{decoder}}
	\end{algorithmic}
\end{algorithm}


\section{Experiments}
\label{sec:chap3-experiments}
\subsection{Toy Experiment}
In order to understand the proposed denoising procedure for VQ-VAE, consider a simple toy setting in which there is no encoder nor decoder, and the codebooks $\{\codebook_j\}_{0\leqslant j \leqslant K-1}$ are fixed. In this case, with $d=2$ and $N=5$, $y = \latentcont^0 \in \rset^{2\times 5}$. We choose $K=8$ and the codebooks $\codebook_j = \mu_j \in \rset^2$, $0\leqslant j \leqslant K-1$, are fixed centers at regular angular intervals in $\rset^2$ and shown in Figure~\ref{fig:toydata}; the latent states $(\quantized^t)_{1\leq t\leq T}$ lie in $\{\codebook_0,\ldots,\codebook_7\}^5$. Data generation proceeds as follows. First, sample a sequence of $(q_1,\ldots,q_5)$ in $\{0,\dots,7\}$: $q_1$ has a uniform distribution, and, for $s\in\{0,1,2,3\}$, $q_{s+1} = q_s + b_s \mod 8$, where $b_s$ are independent Bernoulli samples with parameter $1/2$ taking values in $\{-1, 1\}$. Conditionally on $(q_1,\ldots,q_5)$, $y$ is a Gaussian random vector with mean $(\codebook_{q_1},\ldots,\codebook_{q_5})$ and variance $\mathbf{I}_{2\times 5}$.

% We consider the following data generation procedure.
% \begin{itemize}
%     \item Sample a sequence of $q \in \{1,\dots,8\}^S$ of $S=5$ integers with temporal dependency: $q_1$ uniform, and $q_{s+1} = q_s + b_s \mod 8$, where $b_s$ are independant Bernouilli samples taking values in $\{-1, 1\}$ with probability $\frac{1}{2}$.
%     \item The function $p_\theta^x(x|\quantized^0)$ is chosen as a Gaussian probability function with mean $\mu_{\quantized^0}$ and variance $\mathbf{I}_2$.
%     %Sample $X_s \sim \mathcal{N}(\mu_{q_s},\,\mathbf{I}_2)$
% \end{itemize}

% , the codebooks $\mu_j = e_j \in \rset^2$ are fixed centres at regular angular intervals in a plane as in the 8 Gaussian toy dataset and shown in Fig \ref{fig:toydata}; $\quantized$ is then the discrete state living in $\{\rme_1,\ldots,\rme_8\}$.

\begin{figure}[h!]
	\centering
	\includegraphics[scale=0.45]{images/diffusion-bridges/toy/centroids.png}
	\caption{Toy dataset, with $K=8$ centroids, and two samples $y = (y_1,y_2,y_3,y_4,y_5)$ in $\rset^{2 \times 5}$ each displayed as $5$ points in $\rset^{2}$ (blue and red points), corresponding to the discrete sequences (red) $(6,5,4,3,2)$ and (blue) $(7,0,1,0,1)$.}
	\label{fig:toydata}
\end{figure}

We train our bridge procedure with $T=50$ timesteps, $\vartheta=2, \eta=0.1$, other architecture details and the neural network $\varepsilon_\theta(\latentcont^t ,t)$ are described in Appendix~\ref{ap:additionaltoy}. Forward noise process and denoising using $\varepsilon_\theta(\latentcont^t ,t)$ are showcased in Figure~\ref{fig:noisedenoise}, and more illustrations and experiments can be found in Appendix~\ref{ap:additionaltoy}.

\begin{figure}[h!]
	\centering
	\includegraphics[scale=0.4]{images/diffusion-bridges/toy/forward_backward_sequence.png}
	\caption{(Left) Forward noise process for one sample. First, one data is drawn ($\latentcont^0(y) =y$ in the toy example) and then $\{\latentcont^t\}_{1\leq t \leq T}$ are sampled under $q_\phi$ and displayed. % corresponding to the discrete sequence $[7,0,1,2,3]$:
	%$X^t_s$ is represented for $0 \leq t \leq 50$ and $s$ the displayed index.
	(Right) Reverse process for one sample $\latentcont^T\sim \mathcal{N}(0, (2\vartheta)^{-1}\eta^2 \mathbf{I}_{dN})$. As expected, the last sample $\latentcont^0$ reaches the neighborhood of $5$ codebooks.}
	%Generated samples have the same underlying discrete structure as the original generation procedure: the generated $X^0_s$ can be discretized by finding the nearest neighbour codebook into the following sequence $(5,6,5,4,3)$. Discrete sequences alongside the process can be found in Appendix~\ref{ap:discretetoy}} %It generates a valid sequence $[5,6,5,4,3]$.}
	\label{fig:noisedenoise}
\end{figure}


\paragraph{End-to-end training. } Contrary to VQ-VAE procedures in which the encoder/decoder/codebooks are trained separately from the prior, we can train the bridge prior alongside the codebooks. Consider a new setup, in which the $K=8$ codebooks are randomly initialized and considered as parameters of our model (they are no longer fixed to the centers of the data generation process $\mu_j$). The first part of our loss function, in conjunction with the Gumbel-Softmax trick makes it possible to train all the parameters of the model end-to-end. Details of the procedure and results are shown in Appendix~\ref{ap:end2end}.


% \paragraph{Selected Metrics}
% \begin{itemize}
%     \item NLL on the latent space
%     \item FID on images
%     \item precision/recall (cf charles)
%     \item evaluation of the perfs of the model
% \end{itemize}

\subsection{Image Synthesis}
\subsubsection{Protocol}
In this section, we focus on image synthesis using CIFAR10 and miniImageNet datasets. The goal is to evaluate the efficiency and properties of our model compared to the original PixelCNN. Note that for fair comparisons, the encoder, decoder and codebooks are pretrained and fixed for all models, only the prior is trained and evaluated here. As our goal is the comparison of priors, we did not focus on building the most efficient VQ-VAE, but rather a reasonable model in terms of size and efficiency.

\paragraph{CIFAR10. }
The CIFAR dataset consists of inputs $y$ of dimensions $32 \times 32$ with 3 channels. The encoder projects the input into a grid of continuous values $\latentcont^0$ of dimension $8 \times 8 \times 128$. After discretisation, $\{\quantized^t\}_{0\leqslant t\leqslant T}$ are in a discrete latent space induced by the VQ-VAE which consists of values in $\{1,\ldots,K\}^{8 \times 8}$ with $K=256$. The pre-trained VQ-VAE reconstructions can be seen in Figure~\ref{fig:cifar_vqvae} in Appendix~\ref{ap:additional_visuals}.

\paragraph{miniImageNet. }
\textit{mini}ImageNet was introduced by \cite{Vinyals2016MatchingNF} to offer more complexity than CIFAR10, while still fitting in memory of modern machines.
600 images were sampled for 100 different classes from the original ImageNet dataset, then scaled down, to obtain 60,000 images of dimension $84 \times 84$.
In our experiments, we trained a VQVAE model to project those input images into a grid of continuous values $\latentcont^0$ of dimensions $21 \times 21 \times 32$, see Figure~\ref{fig:miniimagenet_vqvae} in Appendix~\ref{ap:additional_visuals}.
The associated codebook contains $K=128$ vectors of dimension $32$.

\paragraph{Prior models. }
Once the VQ-VAE is trained on the miniImageNet and CIFAR datasets, the $84\times 84 \times 3$ and $32\times 32 \times 3$ images respectively are passed to the encoder and result in $21 \times 21$ and $8 \times 8$ feature maps respectively. From this model, we extract the discrete latent states from training samples to train a PixelCNN prior and the continuous latent states for our diffusion.
Concerning our diffusion prior, we choose the Ornstein-Uhlenbeck process setting $\eta = \sqrt{2}$, $z_*=0$ and $\vartheta = 1$, with $T=1000$.

% We trained a PixelCNN as a prior on the latent space, as described in the original VQVAE paper. Sampling are displayed in Figure~\ref{fig:miniimagenet_prior_pixelcnn}

\paragraph{End-to-End Training.}
As an additional experiment, we propose an End-to-End training of the VQ-VAE and the diffusion process. To speed up training, we first start by pretraining the VQ-VAE, then learn the parameters of our diffusion prior alongside all the VQ-VAE parameters (encoder, decoder and codebooks). Note that in this setup, we cannot directly compare the NLL to PixelCNN or our previous diffusion model as the VQ-VAE has changed, but we can compare image generation metrics such as FID and sample quality.

\subsubsection{Quantitative results}
We benchmarked our model using three metrics, in order to highlight the performance of the proposed prior, the quality of produced samples as well as the associated computation costs.
Results are given as a comparison to the original PixelCNN prior for both the \textit{mini}ImageNet (see Table \ref{tab:miniimagenet}) and the CIFAR10 (see Table~\ref{tab:cifar}) datasets.

\paragraph{Negative Log Likelihood. }\label{nll_paragraph}
Unlike most related papers, we are interested in computing the Negative Log Likelihood (NLL) directly in the latent space, as to evaluate the capacity of the priors to generate coherent latent maps.
To this end, we mask a patch of the original latent space, and reconstruct the missing part, similar to image inpainting, following for instance \cite{van2016pixel}.
In the case of our prior, for each sample $y$, we mask an area of the continuous latent state $\latentcont^0$, i.e. we mask some components of $\latentcont^0$, and aim at sampling the missing components given the observed ones using the prior model. Let $\underline{\quantized}^0$ and $\underline{\latentcont}^0$ (resp. $\overline{\quantized}^0$ and $\overline{\latentcont}^0$) be the masked (resp. observed) discrete and continuous latent variables. The target conditional likelihood is
\begin{align*}
	p_{\theta}(\underline{\quantized}^0|\overline{\latentcont}^0) & = \int p_{\theta}(\underline{\quantized}^0,\underline{\latentcont}^0|\overline{\latentcont}^0)\mathrm{d} \underline{\latentcont}^0\,,                                      \\
	                                                              & = \int p_{\theta}(\underline{\quantized}^0|\underline{\latentcont}^0)p_{\theta}(\underline{\latentcont}^0|\overline{\latentcont}^0)\mathrm{d} \underline{\latentcont}^0\,.
\end{align*}
This likelihood is intractable and replaced by a simple Monte Carlo estimate $\hat{p}_{\theta}(\underline{\quantized}^0|\underline{\latentcont}^0)$ where $\underline{\latentcont}^0\sim p_{\theta}(\underline{\latentcont}^0|\overline{\latentcont}^0)$. Note that conditionally on $\underline{\latentcont}^0$ the components of $\underline{\quantized}^0$ are assumed to be independent but $\underline{\latentcont}^0$ are sampled jointly under $p_{\theta}(\underline{\latentcont}^0|\overline{\latentcont}^0)$. As there are no continuous latent data in PixelCNN, $p_{\theta}(\underline{\quantized}^0|\overline{\quantized}^0)$ can be directly evaluated.

\paragraph{Fr\'echet Inception Distance. }
We report Fr\'echet Inception Distance (FID) scores by sampling a latent discrete state $\quantized \in \embedspace^N$ from the prior, and computing the associated image through the VQ-VAE decoder. In order to evaluate each prior independently from the encoder and decoder networks, these samples are compared to VQ-VAE reconstructions of the dataset images.



\paragraph{Kullback-Leibler divergence. }
In this experiment, we draw $M=1000$ samples from test set and encode them using the trained VQ-VAE, and then draw as many samples from the pixelCNN prior, and our diffusion prior. We propose then to compute the empirical Kullback Leibler (KL) divergence between original and sampled distribution at each pixel. Figure~\ref{fig:klmap} highlights that PixelCNN performs poorly on the latest pixels (at the bottom) while our method remains consistent. This is explained by our denoising process in the continuous space which uses all pixels jointly while PixelCNN is based on an autoregressive model.
\begin{figure}[htpb]
	\centering
	\includegraphics[width=0.49\textwidth]{images/diffusion-bridges/klmap_comparison.png}
	\caption{KL Distance between the true empirical distribution and both prior distributions in the latent space. Darker squares indicates lower (better) values.}
	\label{fig:klmap}
	\vspace{-2mm}
\end{figure}

\begin{table}[htpb]
	\centering
	\begin{tabular}{c c}
		\toprule
		         & KL          \\
		\toprule
		Ours     & {\bf 0.713} \\
		PixelCNN & 0.809       \\
		\bottomrule
	\end{tabular}
	\caption{Averaged KL metric on the feature map.}
	\label{tab:metrics}
	\vspace{-4mm}
\end{table}

\paragraph{Computation times. }
We evaluated the computation cost of sampling a batch of 32 images, on a GTX TITAN Xp GPU card. Note that the computational bottleneck of our model consists of the $T=1000$ sequential diffusion steps (rather than the encoder/decoder which are very fast in comparison). Therefore, a diffusion speeding technique such as the one described in \cite{song2021denoising} would be straightforward to apply and would likely provide a $\times 50$ speedup as mentioned in the paper.


\begin{table}[htpb]
	\centering
	\caption{Results on \textit{mini}ImageNet. Metrics are computed on the validation dataset. The means are displayed along with the standard deviation in parenthesis.}
	\label{tab:miniimagenet}
	\begin{tabular}{llll}
		\toprule
		                               & NLL               & FID & s/sample           \\
		\toprule
		PixelCNN \cite{oord2017neural} & 1.00 ($\pm 0.05$) & 98  & 10.6s ($\pm 28ms$) \\
		Ours                           & 0.94 ($\pm 0.02$) & 99  & 1.7s ($\pm 10ms$)  \\
		\bottomrule
	\end{tabular}
\end{table}

\begin{table}[htpb]
	\centering
	\caption{Results on CIFAR10.
		Metrics are computed on the validation dataset.
		The means are displayed along with the standard deviation in parenthesis.
		NLL for end-to-end takes into account the full model including the modified VQ-VAE, and therefore is not directly comparable to the two others.}
	\label{tab:cifar}
	\begin{tabular}{llll}
		\toprule
		                               & NLL               & FID & s/sample            \\
		\toprule
		PixelCNN \cite{oord2017neural} & 1.41 ($\pm 0.06)$ & 109 & 0.21 ($\pm 0.8ms$)  \\
		Ours                           & 1.33 ($\pm 0.18$) & 104 & 0.05s ($\pm 0.5ms$) \\
		Ours (end-to-end)              & 1.59 ($\pm 0.27$) & 92  & 0.11s ($\pm 0.5ms$) \\
		\bottomrule
	\end{tabular}
\end{table}


% \paragraph{Prior models}
% Once the VQ-VAE is trained on the miniImageNet dataset, the $84\times 84 \times 3$ images are passed to the encoder result in a $21 \times 21$ feature map. From this model, we extract the discrete latent states to train a PixelCNN prior and  the continuous latent states for our diffusion.
% Concerning our Diffusion prior, we choose the Ornstein-Uhlenbeck process setting $\eta = \sqrt{2}$, $z_*=0$ and $\vartheta = 1$, with $T=1000$
% and report visuals results on conditional and unconditional sampling from the prior.

\subsubsection{Qualitative results}

\begin{figure}[h!]
	%\ContinuedFloat

	\begin{subfigure}{\linewidth}
		\centering
		\includegraphics[width=1.\linewidth]{images/diffusion-bridges/sampling.png}
		\caption{Samples from our diffusion prior.}
		\label{fig:diffusion_samples}
	\end{subfigure}
	\begin{subfigure}{\linewidth}
		\centering
		\includegraphics[width=1.\linewidth]{images/diffusion-bridges/sampling_pixelcnn.png}
		\caption{Samples from the PixelCNN prior.}
		\label{fig:pixel_samples}
	\end{subfigure}
	\caption{Comparison between samples from our diffusion-based prior (top) and PixelCNN prior (bottom).}
	\label{fig:figures}
\end{figure}


\begin{figure}[ht]
	\centering
	\includegraphics[width=1\linewidth]{images/diffusion-bridges/conditional_sampling_chain.png}
	\caption{Sampling denoising chain from $t=500$ up to $t=0$, shown at regular intervals, conditioned on the outer part of the picture. We show only the last $500$ steps of this process, as the first $500$ steps are not visually informative. The sampling procedure is described in Appendix~\ref{ap:inpainting}.}
	\label{fig:miniimagenet_prior_ours_chain}
\end{figure}


\begin{figure}[ht]
	\centering
	\includegraphics[width=1\linewidth]{images/diffusion-bridges/sampling_chain.png}
	\caption{Sampling denoising chain from $t=500$ up to $t=0$, shown at regular intervals, unconditional. We show only the last $500$ steps of this process, as the first $500$ steps are not visually informative. The sampling procedure is described in Algorithm~\ref{alg:sample}}
	\label{fig:miniimagenet_prior_ours_chain_unconditional}
\end{figure}

\paragraph{Sampling from the prior. }
%The samples shown in this section depend on the performance of the VQ-VAE model, and for this reason we show the image reconstruction when necessary.
Samples from the PixelCNN prior are shown in Figure \ref{fig:pixel_samples}
and samples from our prior in Figure \ref{fig:diffusion_samples}. Additional samples are given in Appendix~\ref{ap:additional_visuals}. Note that contrary to original VQ-VAE prior, the prior is not conditioned on a class, which makes the generation less specific and more difficult. However, the produced samples illustrate that our prior can generate a wide variety of images which show a large-scale spatial coherence in comparison with samples from PixelCNN.

\paragraph{Conditional sampling. }
As explained in Section~\ref{nll_paragraph}, for each sample $y$, we mask some components of $\latentcont^0(y)$, and aim at sampling the missing components given the observed ones using the prior models. This conditional denoising process is further explained for our model in Appendix~\ref{ap:inpainting}. To illustrate this setting, we show different conditional samples for 3 images in Figure~\ref{fig:miniimagenet_prior_ours_conditional} and Figure~\ref{fig:miniimagenet_prior_ours_conditional:topleft} for both the PixelCNN prior and ours. In Figure~\ref{fig:miniimagenet_prior_ours_conditional}, the mask corresponds to a $9\times 9$ centered square over the $21\times 21$ feature map. In Figure~\ref{fig:miniimagenet_prior_ours_conditional:topleft}, the mask corresponds to a $9\times 9$ top left square. These figures illustrate that our diffusion model is much less sensitive to the selected masked region than PixelCNN. This may be explained by the use of our denoising function $\varepsilon_\theta$ which depends on all conditioning pixels while PixelCNN uses a hierarchy of masked convolutions to enforce
a specific conditioning order. Additional conditional sampling experiments are given in Appendix~\ref{ap:additional_visuals}.

\begin{figure}
	\centering
	\includegraphics[width=0.5\linewidth]{images/diffusion-bridges/conditional_sampling_center.png}

	\caption{Conditional sampling with centered mask: for each of the 3 different images, samples from our diffusion are on top and from PixelCNN on the bottom. For each row: the image on the left is the VQVAE masked reconstruction, the image on the right is the full VQ-VAE reconstruction. Images in-between are independent conditional samples from the models.}
	\label{fig:miniimagenet_prior_ours_conditional}
\end{figure}


\begin{figure}
	\centering
	\includegraphics[width=0.5\linewidth]{images/diffusion-bridges/conditional_sampling_topleft.png}

	\caption{Conditional sampling with top left mask: for each of the 3 different images, samples from our diffusion are on top and from PixelCNN on the bottom. For each row: the image on the left is the VQVAE masked reconstruction, the image on the right is the full VQ-VAE reconstruction. Images in-between are independent conditional samples from the models.}
	\label{fig:miniimagenet_prior_ours_conditional:topleft}
\end{figure}

\paragraph{Denoising chain. }
In addition to the conditional samples, Figure~\ref{fig:miniimagenet_prior_ours_chain} shows the conditional denoising process at regularly spaced intervals, and Figure~\ref{fig:miniimagenet_prior_ours_chain_unconditional} shows unconditional denoising. Each image of the chain is generated by passing the predicted $\quantized^t$ through the VQ-VAE decoder.

\subsection{Relative humidity forecasting}
\label{sec:chap3-rh-forecasting}
After asserting the quality of the proposed prior model on the traditional image datasets, compared to state of the art approaches, we present results applied on the Relative Humidity dataset.

First, notice that the discrete latent model presented in the previous chapter, see Section~\ref{sec:chap2-vadiltis-model}, can be expressed in the context of our new proposed framework.
We set $N$ as the length of the time series samples ($24$ in the case of our Relative Humidity dataset), and the number of diffusion step $T=0$.
In this context, the lattice of latent quantized vector is one dimensional.
Then, we replace our initial autoregressive, Markovian prior with a diffusion bridge.
Similarly to our previous experiments, this diffusion bridge samples latent vectors conditionally on a set of commands, in order to produce forecasts matching the current state of the building as well as the outside weather.
We choose $T=100$, and optimize the Evidence Lower BOund defined in \ref{eq:chap3-elbo}, with the encoder function $f_\phi$ proposed in Section~\ref{sec:chap2-vadiltis-model}.

As presented in Table~\ref{tab:chap3-rhdataset}, the performance of this new model are encouraging when compared to our benchmark, in particular to the previous discrete latent model approach.
We compared the confidence intervals produced by both methods, results are displayed for two samples of the validation set in Figure~\ref{fig:chap3-rhdataset}.
There still remains multiple limitations, in particular the much higher computation time required, which is not unusual for such a novel approach.
Methods for reducing the sampling time have already been proposed in the literature, see \cite{song2021denoising} for instance.
In addition, tuning the parameters of the diffusion bridges has been much more challenging than for the previous Markovian priors.
In Section~\ref{sec:chap3-extension-dicrete-data}, we discuss an extension of diffusion bridges applied to dicrete data.

\begin{table}[htpb]
	\centering
	\caption{\textbf{Relative Humidity dataset.} Comparison of RMSE, MAE and computation time of our model against the previously proposed discrete latent architecture (see Section~\ref{sec:chap2-vadiltis-model}), the benchmarked VQ-VAE, HMM, as well as our decoupled architecture (see Section~\ref{sec:chap2-decoupled-architecture}).
		We report performance on par with these benchmarked models.
		This table also highlights one major limitation of this new approach: the high computation time.
		We believe that further works toward diffusion bridges will eventually address this problem, as already seen in \cite{song2021denoising}.
		This table provides aggregated results of the predictions on the entire validation set.
		Mean values of the estimators, taken over the validation samples of the dataset, are displayed along with their variance.}
	\label{tab:chap3-rhdataset}
	\begin{tabular}{llll}
		\toprule
		                  & RMSE            & MAE             & Computation time \\
		\toprule
		HMM               & $0.46 \pm 0.19$ & $0.40 \pm 0.17$ & $99 ms$          \\
		VQ-VAE            & $0.55 \pm 0.33$ & $0.51 \pm 0.32$ & $39 ms$          \\
		\toprule
		SMCL              & $0.30 \pm 0.19$ & $0.26 \pm 0.16$ & $21 ms$          \\
		Vadiltis (gru)    & $0.30 \pm 0.19$ & $0.24 \pm 0.15$ & $39 ms$          \\
		\toprule
		Diffusion bridges & $0.29 \pm 0.19$ & $0.24 \pm 0.16$ & $2,159 ms$       \\
		\bottomrule
	\end{tabular}
\end{table}

\begin{figure}[htpb]
	\centering
	\caption{Prediction of Relative Humidity on two samples from the validation dataset.
		Each box contains 75\% of samples, while the whiskers cover 95\%.
		The produced confidence intervals are coherent with previous approaches.}
	\includegraphics[width=0.7\linewidth]{images/airq/diffusion_bridge/ci_oze_1.png}
	\includegraphics[width=0.7\linewidth]{images/airq/diffusion_bridge/ci_oze_2.png}
	\label{fig:chap3-rhdataset}
\end{figure}

\clearpage


\section{Extension of discrete diffusion}
\label{sec:chap3-extension-dicrete-data}
In this section, we propose an extension to probabilistic diffusion models applied to discrete latent states.
We consider a set of discrete observations $\quantized \in \embedspace^N$, where $\embedspace = \{\codebook_1, \cdots, \codebook_K\}$, with $\codebook_k \in \rset^d$ for all $1 \leq k \leq K$.
For the sake of visualization, and in order to compare diffusion methods directly on a discrete example, we propose a simple toy dataset of 5 letter words, whereby $K=26$, $N=5$.
Only a few combinations of 5 letters $(\quantized_k)_{k=1}^5$ result in an existing word.
Once presented, we detail the results of our extended method on our benchmark dataset, the relative humidity forecasting task.

\subsection{Motivations}
Diffusion bridges applied directly on discrete random variables have already been proposed, such as the multinomial diffusion \cite{hoogeboom2021argmax}, where the authors work within the Categorical distribution space, modeling the probabilities in a $K \times N$ space.
Their forward noise process consists of sampling a random $i \in \{1, \ldots, N\}$ and sampling $\quantized^i$ from a uniform distribution.
This however, seems to suffer from limitations, one of which being the inability to scale with large vocabularies $K$, which is the case in language models ($K \sim 50,000$) or VQ-VAEs ($K \sim 4,000$ or more).

We postulate that using a continuous diffusion in an embedded space $\mathsf{X}\subset \rset^{d \times N}$is more appropriate as 1) it leverages recent advances in continuous diffusions and 2) it enables to scale better, as $d$ can remain small compared to $K$, typically in word embeddings $d$ evolves as $\log K$.
This embedding space can be given, created or trained.
We will focus on a simple application, where $e_k \sim \mathcal{N}(0,\mathbf{I}_{d})\,, \forall 1 \leq k \leq K$ are sampled independently and fixed during the process.

Our first approach was to simply embed the discrete data samples $\quantized$ into the continuous space $\mathsf{X}$ using the embedding projections $e_k, k \in \{1,\ldots,K\}$.
Then, within the continuous space $\mathsf{X}$ we would be able to perform standard continuous denoising diffusion \cite{ho2020denoising}.
In that case, the diffusion process in defined by choosing a non-informative prior distribution, building a forward noising process gradually corrupting the samples in order to reach the prior distribution, and training a denoising model.
In practice, the prior distribution is often a unit Gaussian, the corrupting process a Ornstein-Uhlenbeck and the denoising model a deep neural network.
Once trained, the sampling process consists in drawing a sample $\latentcont^T$ under the prior distribution, computing $T$ denoising steps $p_{\theta, t|t+1}(\latentcont^t | \latentcont^{t+1})$ for $t \in \{T-1, \cdots, 0\}$, and the associated quantized vector $\quantized \sim p_\theta(\quantized^0 | \latentcont^0)$.

Instead of defining the discrete distribution $p_\theta(\quantized | \latentcont)$ as a Dirac on the nearest neighbor embedding, $\delta_{e_{k^\star}}(\quantized)$, where $k^\star = \argmin_{1 \leq k \leq K} \{ \| \latentcont - \codebook_k \}$, we sampled a codebook from the following Categorical distribution:
$$p_\theta(\quantized = \codebook_k | \latentcont) = \softmax_{1\leq j \leq K}\{-\|\latentcont - \codebook_j\|_2\}_k\,,$$
for all $1 \leq k \leq K$.

% We now chose to compute a distance to the codebooks through the dot product:
% $$p_\theta(\quantized = \codebook_k | \latentcont) = \softmax_{1\leq j \leq K}\{\latentcont \cdot \frac{\codebook_j^\top}{\|\codebook_j\|_2} \}_k\,.$$
% This will not impact future computations as $\|\latentcont - \codebook_k\|^2_2\ = \|\latentcont\|_2^2 + \|\codebook_k\|^2_2 - 2 \latentcont \codebook_k^T$, and we could control $\|\codebook_k\|^2_2$ to be constant (normalized embeddings), and we could also control $\|\latentcont\|_2^2$, see below.

\subsection{Limitations}
Whenever we experiment our proposed continuous diffusion on a high dimensional latent space, we notice a scaling issue.
As the corrupting process adds noise independently and identically on all dimensions, the final sample of the noising chain $\latentcont^T$ may be located quite far from the codebooks.
Even in the context of our 5-letter word toy example, our diffusion leads to geometric problems, as shown in Figure~\ref{fig:trajectory}.
There, we plotted three denoising trajectories sampled after training a simple diffusion bridge.

Because the training procedure will direct the denoising process towards the codebooks, this limitation may be mitigated after reaching a good estimate of the models parameters.
However, this implies long and complex trainings, and could impact the final performance of the diffusion bridge.

We now investigate a more sophisticated corrupting process, which aims at directing the noising towards the codebooks in the latent space.
As we present in the next section, such an improvement can be incorporated directly in our mathematical framework.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.5\linewidth]{images/diffusion-bridges/trajectory.png}
	\caption{PCA projection of embeddings of each letter and denoising diffusion trajectories.
		Because of a scaling problem, the starting point of the denoising diffusion $\latentcont^T$ is very far from the codebooks $(e_k)_{k=1}^K$, and the denoising process stay very far from the embeddings, resulting in exploration problems (not all embeddings are reachable, therefore the model will have trouble predicting some of them).}
	\label{fig:trajectory}
\end{figure}

\subsection{Embedding-guided denoising}

Let $\mu$ be the empirical mean vector of the codebooks, and $M$ their covariance matrix:
$$
	\mu = \frac{1}{K}\sum_{j=1}^K\codebook_k \,,\quad M = \frac{1}{K}\sum_{j=1}^K\left(\codebook_k - \mu \right)\left(\codebook_k - \mu \right)^\top\,.
$$
Consider that the noising process boils down to sampling solution to the following Stochastic Differential Equation (SDE) in $\mathbb{R}^d$:
\begin{equation}
	\label{eq:ou}
	\mathrm{d}Z_t = \vartheta (Z_t - \mu)\mathrm{d}t + \eta M^{1/2}\mathrm{d}W_t\,,
\end{equation}
We can define the variational density by integrating this SDE along small step-sizes.
In this setting, $q^{\latentcont}_{\phi,t|t-1}(\latentcont^t|\latentcont^{t-1})$ is a Gaussian probability density function with mean vector $\mu + (\latentcont^{t-1} - \mu) \mathrm{e}^{-\vartheta \delta_t}$ and covariance matrix $(2\vartheta)^{-1} \eta^2 (1-\mathrm{e}^{-2\vartheta\delta_t})M$.
The denoising process amounts then to sampling from the law of $\latentcont^{t-1}$ given $\latentcont^0$ and $\latentcont^t$, a Gaussian probability density function with mean:
$$
	\tilde \mu_{\phi,t-1|0,t}(\latentcont^0,\latentcont^t) = \frac{\beta_t}{1-\bar{\alpha}_t}\{\sqrt{\bar{\alpha}_{t-1}}\latentcont^0+(1-\sqrt{\bar{\alpha}_{t-1}})\mu\} + \frac{1-\bar{\alpha}_{t-1}}{1-\bar{\alpha}_t}\sqrt{\alpha_t} \{\latentcont^t-(1-\sqrt{\alpha_t})\mu\}
$$
and covariance matrix
$$
	\tilde \sigma^2_{\phi,t-1|0,t} = \frac{1}{2\vartheta}\frac{1- \bar \alpha_{t-1}}{1- \bar \alpha_{t}}\beta_t\, M\,,
$$
with the same notation $\alpha$, $\bar \alpha$ and $\beta$ as introduced in Section~\ref{sec:chap3-ou-process}.
Note that under $q_\phi$, $\latentcont^t$ has the same distribution as $\latentcontpred^t(\latentcont^{0},\varepsilon_t) = \sqrt{\bar \alpha_t}\latentcont^{0} + (1-\sqrt{\bar \alpha_t})\mu + \sqrt{\frac{1}{2\vartheta}(1-\bar\alpha_t)}M^{1/2}\varepsilon_t$, where $\varepsilon_t \sim \mathcal{N}(0,\mathbf{I})$.
Then, $\tilde \mu_{\phi,t-1|0,t}$ can be reparameterised as follows:
$$
	\tilde \mu_{\phi,t-1|0,t}(\latentcont^0,\varepsilon_t) = \frac{1}{\sqrt{\alpha_t}}\left(\latentcontpred^t(\latentcont^0,\varepsilon_t) - \sqrt{\frac{1}{2\vartheta (1-\bar{\alpha}_t)}}\beta_tM^{1/2}\varepsilon_t\right)\,.
$$
We therefore propose to use
$$
	\mu_{\theta,t-1|t}(\latentcont^{t},t) = \frac{1}{\sqrt{\alpha_t}}\left(\latentcont^t - \sqrt{\frac{1}{2\vartheta (1-\bar{\alpha}_t)}}\beta_tM^{1/2}\varepsilon_\theta(\latentcont^{t},t)\right)\,.
$$

We demonstrate the impact of this extension in Figure~\ref{fig:trajectory_egd}, and detail its performance on the Relative Humidity dataset in the next chapter.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.5\linewidth]{images/diffusion-bridges/gumbeldiff.png}
	\caption{PCA projection of embeddings of each letter and guided denoising diffusion trajectories.}
	\label{fig:trajectory_egd}
\end{figure}

\subsection{Results on the Relative Humidity dataset}
In order to benchmark this extension, we run the same experiments as presented in Section~\ref{sec:chap3-rh-forecasting}, where we train a diffusion bridge prior model on the relative humidity forecasting task.
Although we could not obtain any noticeable improvement compared to the initially proposed diffusion bridge, regarding the RMSE criteria, our model now requires much less training epochs in order to converge (5 epochs for the embedded guided diffusion against over 50 for the previous diffusion).
As an illustration, we plotted the evolution of the ELBO, as well as the RMSE criteria, over the training epochs for the simple diffusion (as presented in the previous Section) compared to the Extended guided diffusion, see Figure~\ref{fig:chap3-diffusion-comparison}.
These results comfort our intuition that the scaling issue, arising from adding noise independently and identically in all dimensions of the latent space, makes the training procedure much more complex.
Although this limitation may be mitigated during the training procedure, the embedded guided diffusion offer an efficient alternative to the corrupting and reconstruction process, without suffering any additional computational cost or implementation complexity.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.5\linewidth]{images/diffusion-bridges/diffusion_comparison_elbo.png}
	\includegraphics[width=0.5\linewidth]{images/diffusion-bridges/diffusion_comparison_rmse.png}
	\caption{Comparison of the evolution of the ELBO, as well as the RMSE criteria, over the training epochs of the simple diffusion presented in the previous Section, compared to the Extended guided diffusion.
	The latter version is able to converge much more quickly, although the resulting RMSE in not significantly higher.
	}
	\label{fig:chap3-diffusion-comparison}
\end{figure}

\section{Conclusion}
\label{chap3-conclusion}
In the previous chapter, we showed that discrete latent models offer performance on par with their continuous counterparts, while allowing simpler training procedures.
In this chapter, we aimed at exploring more diverse and complex architectures.

Recent discrete latent models found in the literature are often benchmarked on computer vision tasks, such as image synthesis or inpainting.
In our exploration, we found that these models rely on very complex, hard to train, autoregressive priors, presenting two main limitations: the autoregressive nature of the prior models do not always match the latent space structure, and estimating their parameters require a subsequent training procedure.
In order to address these shortcomings, and to compare recent models on a theoretically grounded benchmark, we proposed a new mathematical framework for discrete latent models.
By proposing a novel method for modelling the discrete latent space, we allow for more generic prior models, and bypass the need for a two step training.

Modelling the discrete distribution of the latent space is a complex task, for which no satisfactory method exists yet.
We proposed instead to map discrete vectors to a continuous space, through a set of learned embeddings.
This allows us to leverage known modelling tools, such as such as diffusion bridges, and scales much better to high dimension spaces than purely discrete alternatives.
Our framework allows for any law between the continuous and discrete spaces.
We hope that it will serve as a sound and stable foundation to derive future generative models.

We then demonstrated the performance of our framework on an image synthesis, and an inpainting task, where our proposed model is able to generate complex, coherent samples, competitive with state of the art methods.
We also successfully applied our proposed methodology on the Relative Humidity dataset.
We believe that these first numerical experiments open up many research avenues, such as scaling to larger models, optimal scaling of the hyperparameters, alternative diffusion methods, or studying the influence of the regularization loss for end-to-end training.

In a last section, we extended our initial diffusion bridge to improve the noising and denoising processes in the context of embedding vectors, such as the codebooks.
This allowed to improve training performance, by greatly reducing the number of epochs before convergence of the model.
It also brings forth a new approach to apply diffusion bridges to inherent discrete tasks, such as Natural Language Processing.

\clearpage
\bibliographystyle{apalike}
\bibliography{src/chap3/references}
